//I2CCu for H8/3664
//        by I.N.

//2013.07.17 ver.0.1

//^CAEg(P:us)
#define I2C_TIMEOUT 10000

// n=0~1000(us) for AKI-H8(16.0MHz)
void waitus(unsigned char n)
{
	unsigned int i,j,k;
	for(i=0;i<n;i++){
		j++;
		k++;
	}
}

// n=0~65535(ms) for AKI-H8(16.0MHz)
void waitms(unsigned int n)
{
	unsigned int i;
	for(i=0;i<n;i++){
		waitus(1000);
	}
}

//I2CWX^\
struct st_iic {				// struct IIC 
	union {					// ICCR 
		unsigned char BYTE; // Byte Access 
		struct {			// Bit Access 
			unsigned char ICE :1; // ICE 
			unsigned char IEIC:1; // IEIC 
			unsigned char MST :1; // MST 
			unsigned char TRS :1; // TRS 
			unsigned char ACKE:1; // ACKE 
			unsigned char BBSY:1; // BBSY 
			unsigned char IRIC:1; // IRIC 
			unsigned char SCP :1; // SCP 
		} BIT;
	} _ICCR;

	union {					// ICSR 
		unsigned char BYTE; // Byte Access 
		struct {			// Bit Access 
			unsigned char ESTP:1; // ESTP 
			unsigned char STOP:1; // STOP 
			unsigned char IRTR:1; // IRTR 
			unsigned char AASX:1; // AASX 
			unsigned char AL  :1; // AL 
			unsigned char AAS :1; // AAS 
			unsigned char ADZ :1; // ADZ 
			unsigned char ACKB:1; // ACKB 
		} BIT;
	} _ICSR;

	union {
		struct {
			union {			// SARX 
				unsigned char BYTE; // Byte Access 
				struct {			// Bit Access 
					unsigned char SVAX:7; // SVAX 
					unsigned char FSX :1; // FSX 
				} BIT;
			} UN_SARX;
			union {			// SAR 
				unsigned char BYTE; // Byte Access 
				struct {			// Bit Access 
					unsigned char SVA:7; // SVA 
					unsigned char FS :1; // FS 
				} BIT;
			} UN_SAR;
		} ICE0;
		struct {
			unsigned char UN_ICDR;	// ICDR 
			union {					// ICMR 
				unsigned char BYTE; // Byte Access 
				struct {			// Bit Access 
					unsigned char MLS :1; // MLS 
					unsigned char WAIT:1; // WAIT 
					unsigned char CKS :3; // CKS 
					unsigned char BC  :3; // BC 
				} BIT;
			} UN_ICMR;
		} ICE1;
	} EQU;
};

#define _IIC	(*(volatile struct st_iic *)0xFFC4)		// IIC Address 

//I2CG[R[h
#define	I2C_BBSY_TOUT	1
#define I2C_IRIC_TOUT	2
#define I2C_ACKB_TOUT	3
#define I2C_IRTR_TOUT	4
#define I2C_TRS_TOUT	5

//I2Cݒ
void i2c_begin(void)
{
	//X[u[h̃AhXݒ(}X^̏ꍇC֌WȂ)
	#define I2C_SLAVE_ADR 0x01
	_IIC.EQU.ICE0.UN_SAR.BYTE= I2C_SLAVE_ADR<<1 ;
	SARX= 0x01;	//SARX͎gȂ

	ICCR=0x89;	//I2CgpJn(ICE=1) P56,P57SDA,SCLɂȂ

	ICMR=0x08;	//CKS2..0=001
	TSCR=0x01;	//0x01=200kHz
}

//I2C ACK҂
int i2c_waitAck(void)
{
	int t;

	// ICCR(IRIC)=1mF
	t=I2C_TIMEOUT;
	while(_IIC._ICCR.BIT.IRIC==0){
		if(t==0) return I2C_IRIC_TOUT;	// timeout
		t--;
		waitus(1);
	}

	// ICSR(ACKB)=0mF
	t=I2C_TIMEOUT;
	while(_IIC._ICSR.BIT.ACKB==1){
		if(t==0) return I2C_ACKB_TOUT;	// timeout
		t--;
		waitus(1);
	}

	return 0;
}

//I2Cf[^ݒ菈
int i2c_write(unsigned char d)
{
	int t;

	// ICCR(IRIC)=1mF
	t=I2C_TIMEOUT;
	while(_IIC._ICCR.BIT.IRIC==0){
		if(t==0) return I2C_IRIC_TOUT;	// timeout
		t--;
		waitus(1);
	}

	_di();
	ICDR=d;					//f[^
	_IIC._ICCR.BIT.IRIC=0;	//ICCR(IRIC)NA
	_ei();

	return i2c_waitAck();	//Acknowlege҂
}

//MJnݒ
int i2c_beginTransmission(unsigned char adr)
{
	int r,t;

	// I2C BUS̊J҂
	// ICCR(BBSY)=0mF
	t=I2C_TIMEOUT;
	while(_IIC._ICCR.BIT.BBSY==1){
		if(t==0) return I2C_BBSY_TOUT;	// timeout
		t--;
		waitus(1);
	}

	//}X^M[h
	ICCR=0xB9;
	//Jnݒ
	ICCR=0xBC;

	//slave addressZbg
	r=i2c_write(adr);
	if(r) return r;

	return 0;
}

//I2C IV[PX
int i2c_endTransmission(void)
{
	_IIC._ICCR.BIT.IRIC=0;	//ICCR(IRIC)NA
	ICCR=0xB0;				//~s
	return 0;
}

